#include	"multi_forward.h"

void	status_on (char call[], char ur_call[], char my_call[], char rpt1_call[], char rpt2_call[]);
void	status_off (char call[]);
int	ja_check (char call[]);

extern  struct  sockaddr_in     in_sock;
extern  socklen_t       len_in_sock;

union
{
	struct  dstar_packet    d_packet;
	char    forward_buffer[128];
}       forward_buff;

void    forward_reply (char pkt[])
{
        char    forward_reply_frame[10];
        int     err;
        time_t  atime;

        memset (forward_reply_frame, 0x00, 10);
        memcpy (forward_reply_frame, pkt, 6);
        forward_reply_frame[6] = 'r';

        err = sendto (fwd_sd, forward_reply_frame, 10, 0,
                (struct sockaddr *)&fwd_addr, sizeof(fwd_addr));
        if (err == -1)
        {
                time (&atime);
                fprintf (log_file, "%24.24s sendto (forward reply) error:%s\n",
                        ctime(&atime), strerror(errno));
                fflush (log_file);
        }
}

int	forward_resend (void)
{
	//struct	ModuleTable	*m_pnt;
	int	length;
	time_t	atime;
	//struct	timeval		time_21ms;
	//struct	timeval		cur_time;
	struct	MultiConnectTable	*next;
	int	err;
	struct  area_callsign     *ar_call_next;

	len_fwd_addr = sizeof (fwd_addr);
    	length = recvfrom(fwd_sd, &forward_buff, sizeof(forward_buff), 0, 
		(struct sockaddr *)&fwd_addr, &len_fwd_addr);
	if (length < 0) {
               	time(&atime);
               	fprintf (log_file, "%24.24s xchage data Recv. error\n", ctime(&atime));
		fflush (log_file);
        	return FALSE;			// end
    	}
	
	if (!memcmp(forward_buff.d_packet.id, "DSTR", 4) && (forward_buff.d_packet.sr == 's')) 
	{
		forward_reply((char *)&forward_buff);
	}
	if (length > 10)
	{
		if (length == 58)
		{
			if (!ja_check (forward_buff.d_packet.body.header.rpt1)
				|| !ja_check (forward_buff.d_packet.body.header.rpt2)) return TRUE;
			if ((forward_buff.d_packet.c & C_MASK) == VOICE)	/* dv packet from ZR  (RF header)*/
			{
				if (forward_buff.d_packet.c & ZR)
				{
					if (!memcmp(forward_buff.d_packet.body.header.rpt2, zr_callsign, 7)
						&& (forward_buff.d_packet.body.header.rpt1[7] != 0x20))
					{
                                		ar_call_next = ar_callsign_pnt;
                                		while (ar_call_next)
                                		{
                                      			if (!memcmp (ar_call_next->ar_callsign, forward_buff.d_packet.body.header.rpt1, 8))
                                        		{
								if ((ar_call_next->FrameID[0] == 0x00) && (ar_call_next->FrameID[1] == 0x00))
								{
                                        				memcpy (ar_call_next->FrameID, forward_buff.d_packet.trunk.FrameID, 2);
								}
								goto skip;
                                        		}
                                        		ar_call_next = ar_call_next->next;
                                		}
						goto create;
					}
				}
				else if (forward_buff.d_packet.c & GW) 
				{
					if (!memcmp(forward_buff.d_packet.body.header.rpt1, zr_callsign, 7)
						&& (forward_buff.d_packet.body.header.rpt2[7] != 0x20))
					{
						ar_call_next = ar_callsign_pnt;
						while (ar_call_next)
						{
							if (!memcmp (ar_call_next->ar_callsign, forward_buff.d_packet.body.header.rpt2, 8))
							{
								if ((ar_call_next->FrameID[0] == 0x00) && (ar_call_next->FrameID[1] == 0x00))
								{
									memcpy (ar_call_next->FrameID, forward_buff.d_packet.trunk.FrameID, 2);
								}
								goto skip;
							}
							ar_call_next = ar_call_next->next;
						}
						goto create;
					}
				}
				return  TRUE;

create:
				ar_call_next =  malloc (sizeof(struct area_callsign));
                               	memset (ar_call_next->ar_callsign, 0x20, 8);
				if (forward_buff.d_packet.c & ZR)
                               		memcpy (ar_call_next->ar_callsign, forward_buff.d_packet.body.header.rpt1, 8);
				else if (forward_buff.d_packet.c & GW)
					memcpy (ar_call_next->ar_callsign, forward_buff.d_packet.body.header.rpt2, 8);
				gettimeofday (&ar_call_next->rep_time, NULL);
				memcpy (ar_call_next->FrameID, forward_buff.d_packet.trunk.FrameID, 2);
				if (ar_callsign_pnt == NULL) 
				{
					ar_callsign_pnt = ar_call_next;
					ar_call_next->next = NULL;
				}
				else
				{
					ar_call_next->next = ar_callsign_pnt;
					ar_callsign_pnt = ar_call_next;
				}
skip:
				time (&ar_call_next->status_time);
				if (forward_buff.d_packet.c & ZR) 
					status_on (forward_buff.d_packet.body.header.rpt1,
						forward_buff.d_packet.body.header.urcall,
						forward_buff.d_packet.body.header.mycall,
						forward_buff.d_packet.body.header.rpt1,
						forward_buff.d_packet.body.header.rpt2);
				else if (forward_buff.d_packet.c & GW) 
					status_on (forward_buff.d_packet.body.header.rpt2,
						forward_buff.d_packet.body.header.urcall,
						forward_buff.d_packet.body.header.mycall,
						forward_buff.d_packet.body.header.rpt1,
						forward_buff.d_packet.body.header.rpt2);
				memcpy (ar_call_next->rf_header, &forward_buff, 58);
				ar_call_next->status = ON;
			}
		}
		else if ((length == 29) || (length == 32))
		{
			ar_call_next = ar_callsign_pnt;
			while (ar_call_next)
			{
				if (!memcmp (ar_call_next->FrameID, forward_buff.d_packet.trunk.FrameID, 2))
				{
					time (&ar_call_next->status_time);
					if ((length == 32) || (forward_buff.d_packet.trunk.FrameSeq & 0x40))
					{
						status_off (ar_call_next->ar_callsign);
						memset (ar_call_next->FrameID, 0x00, 2);
					}
					break;
				}
				ar_call_next = ar_call_next->next;
			}
		}
		
		next = MultiConnectTablePnt;
		while (next)
		{
			sendto (multi_sd, &forward_buff, length, 0,
				(struct sockaddr *)&next->multi_addr, sizeof(struct sockaddr));
			if ((forward_buff.d_packet.trunk.FrameSeq  == 0x14) && ar_call_next)
			{
				sendto (multi_sd, &ar_call_next->rf_header, 58, 0, 
					(struct sockaddr *)&next->multi_addr, sizeof(struct sockaddr));
			}
			next = next->f_chain;
		}
	}
	return TRUE;
}

int	forward_init(void)
{
	time_t	atime;

	if (fwd_port > 0)
	{
    		// IPv4 UDP socket
		// monitor port
    		if((fwd_sd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		{
                	time(&atime);
                	fprintf (log_file, "%24.24s Forward  socket not open\n", ctime(&atime));
			fflush (log_file);
        		return FALSE;	
    		}

        	// 待ち受けるIPとポート番号を設定
        	fwd_addr.sin_family = PF_UNSPEC;
        	fwd_addr.sin_port = htons(fwd_port);
        	fwd_addr.sin_addr.s_addr = INADDR_ANY;

		FD_SET (fwd_sd, &fd_save);

    		// Bind
    		if(bind(fwd_sd, (struct sockaddr *)&fwd_addr, sizeof(fwd_addr)) < 0) {
			time(&atime);
			fprintf (log_file, "%24.24s Forward socket not bind %s\n", 
				ctime(&atime), strerror(errno));
			fflush (log_file);
        		return FALSE;
    		}
	}

	return TRUE;
}

void      multi_connect (void)
{
        int     length;
        time_t  atime;
	char	multi_buff[1024];
	struct	MultiConnectTable	*next;
	struct  area_callsign     *ar_call_next;

        len_multi_addr = sizeof (multi_addr);
        length = recvfrom(multi_sd, &multi_buff, sizeof(multi_buff), 0, 
		(struct sockaddr *)&multi_addr, &len_multi_addr);
        if (length < 0) {
                time(&atime);
                fprintf (log_file, "%24.24s Multi forward data Reciv. error\n", ctime(&atime));
		fflush (log_file);
                return;                   // end
        }

	if (!memcmp (multi_buff, "HPCH", 4))
	{
		read_hole_punch(multi_buff, length);
		return;
	}

	next = MultiConnectTablePnt;
	while (next)
	{
		if (!memcmp (&multi_addr, &next->multi_addr, sizeof (multi_addr))) 
		{
			time (&next->AccessTime);
			goto next;
		}
		next = next->f_chain; 
	}
	next = malloc (sizeof(struct MultiConnectTable));
	next->f_chain = MultiConnectTablePnt;
	memcpy (&next->multi_addr, &multi_addr, sizeof (multi_addr));
	time (&next->AccessTime);
	next->in = 0;
	next->out = 0;
	next->gw = 0;
	next->zr = 0;
	MultiConnectTablePnt = next;
	time (&atime);
	fprintf (log_file, "%24.24s Connect from %s(%d)\n", ctime(&atime),
		inet_ntoa (multi_addr.sin_addr), multi_addr.sin_port);
	fflush (log_file);

next:
	if (!memcmp (multi_buff, "DSTR", 4))
	{
                if (length == 58)
                {
			if (!ja_check (&multi_buff[20]) || !ja_check (&multi_buff[28])) return;
			if (memcmp (zr_callsign, &multi_buff[20], 7)) return;
			ar_call_next = ar_callsign_pnt;
                        while (ar_call_next)
                        {
                        	if (!memcmp (ar_call_next->ar_callsign, &multi_buff[28], 8))
                                {
                                	if ((ar_call_next->FrameID[0] == 0x00) && (ar_call_next->FrameID[1] == 0x00))
                                        {
                                        	memcpy (ar_call_next->FrameID, &multi_buff[14], 2);
						//memcpy (&ar_call_next->in_addr, &multi_addr, sizeof(struct sockaddr_in));
                                                status_on (forward_buff.d_packet.body.header.rpt1,
							forward_buff.d_packet.body.header.urcall,
							forward_buff.d_packet.body.header.mycall,
							forward_buff.d_packet.body.header.rpt1,
							forward_buff.d_packet.body.header.rpt2);
						time (&ar_call_next->status_time);
						memcpy (ar_call_next->rf_header, &forward_buff, 58);
                                        }
					break;
                                }
                                ar_call_next = ar_call_next->next;
                   	}
			if (ar_call_next == NULL) return; 
                }
                else if ((length == 29) || (length == 32))
                {
                        ar_call_next = ar_callsign_pnt;
                        while (ar_call_next)
                        {
				if (!memcmp (ar_call_next->FrameID, &multi_buff[14], 2))
                                //if (!memcmp (ar_call_next->FrameID, &multi_buff[14], 2)
				//	&& !memcmp (&ar_call_next->in_addr, &multi_addr, sizeof(struct sockaddr_in)))
                                {
					time (&ar_call_next->status_time);
                                        if ((length == 32) || (multi_buff[16] & 0x40))
                                        {
                                                status_off (ar_call_next->ar_callsign);
                                                memset (ar_call_next->FrameID, 0x00, 2);
                                        }
					break;
                                }
                                ar_call_next = ar_call_next->next;
                        }
			if (ar_call_next == NULL) return;
                }
		ar_call_next = ar_callsign_pnt;
		while (ar_call_next)
		{
			if (!memcmp (ar_call_next->FrameID, &multi_buff[14], 2))
			//if (!memcmp (ar_call_next->FrameID, &multi_buff[14], 2)
			//	&& !memcmp (&ar_call_next->in_addr, &multi_addr, sizeof(struct sockaddr_in)))
			{
				multi_buff[7] |= FWD;
				sendto (fwd_sd,  &multi_buff, length, 0,
					(struct sockaddr *)&fwd_addr, sizeof(fwd_addr));
	
				next = MultiConnectTablePnt;
				while (next)
				{
					if (memcmp (&next->multi_addr, &multi_addr, sizeof(multi_addr)))
					{
						sendto (multi_sd, &multi_buff, length, 0,
							(struct sockaddr *)&next->multi_addr,
					 		sizeof(struct sockaddr));
                        			if ((multi_buff[16] == 0x14) && ar_call_next)
                        			{
                                			sendto (multi_sd, &ar_call_next->rf_header, 58, 0,
                                      				(struct sockaddr *)&next->multi_addr, sizeof(struct sockaddr));
                        			}
						next->out++;
					}
					else
					{
						next->in++;
						if (multi_buff[7] & GW) next->gw++;
						if (multi_buff[7] & ZR) next->zr++;
					}
					next = next->f_chain;
				}
				return;
			}	
			ar_call_next = ar_call_next->next;
		}
	}
        return;
}
